unit pi_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Zeichenblatt: TPaintBox;
    DiagonaleBtn: TButton;
    ParabelBtn: TButton;
    KreisBtn: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure ZeichenblattPaint(Sender: TObject);
    procedure DiagonaleBtnClick(Sender: TObject);
    procedure KreisBtnClick(Sender: TObject);
    procedure ParabelBtnClick(Sender: TObject);
  private
    zbw,zbh : integer;
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
with Zeichenblatt do begin
  left := 10; top := 10;
  zbh := 300; height := zbh;
  zbw := 300; width := zbw;
end;
randomize;
end;



procedure TForm1.ZeichenblattPaint(Sender: TObject);
begin
with Zeichenblatt.Canvas do begin
  Brush.Color := clWhite;
  FillRect(Rect(0,0,zbh,zbw));
end;
end;

procedure TForm1.DiagonaleBtnClick(Sender: TObject);
var x,y,z,zi,za : integer;
begin
ZeichenblattPaint(Self);
with Zeichenblatt.Canvas do begin
  Pen.Color := clRed;
  moveto(0,zbh); lineto(zbw,0);
end;
zi := 0; za := 0;
for z := 1 to 30000 do begin
  x := random(zbw); y := random(zbh);
  ZeichenBlatt.Canvas.Pixels[x,y] := clGreen;
  if y < x then inc(za) else inc(zi);
end;
Edit1.Text := IntToStr(za);Edit2.Text := IntToStr(zi);
Edit3.Text := Format('%6.4f', [zi/(zi+za)])
end;


procedure TForm1.KreisBtnClick(Sender: TObject);
var x,y,z,zi,za : integer;
begin
ZeichenblattPaint(Self);
for x := 0 to zbw do begin
  y := round(sqrt(zbw*zbw  - x*x));
  ZeichenBlatt.Canvas.Pixels[x,y] := clRed;
end;
zi := 0; za := 0;
for z := 1 to 60000 do begin
  x := random(zbw); y := random(zbh);
  ZeichenBlatt.Canvas.Pixels[x,y] := clGreen;
  if y >= round(sqrt(zbw*zbw - x*x)) then inc(za) else inc(zi);
end;
Edit1.Text := IntToStr(za);Edit2.Text := IntToStr(zi);
Edit3.Text := Format('%6.4f', [zi/(zi+za)])

end;

procedure TForm1.ParabelBtnClick(Sender: TObject);
var x,y,z,zi,za : integer;
begin
ZeichenblattPaint(Self);
for x := 0 to zbw do begin
  y := zbh-round(x*x/zbw);
  ZeichenBlatt.Canvas.Pixels[x,y] := clRed;
end;
zi := 0; za := 0;
for z := 1 to 60000 do begin
  x := random(zbw); y := random(zbh);
  ZeichenBlatt.Canvas.Pixels[x,y] := clGreen;
  if y >= zbh-round(x*x/zbw) then inc(za) else inc(zi);
end;
Edit1.Text := IntToStr(za);Edit2.Text := IntToStr(zi);
Edit3.Text := Format('%6.4f', [zi/(zi+za)])

end;

end.
